/* ̧قDoxygenpɏĂ܂B				 */
/*! \file *********************************************************************
 *
 * \brief
 *		RCU̸ۯ̍Z\p̊֐
 *
 *		p̊֐: QƊƂĒᑬRCōRC̍ZAx̒ᑬRC\
 *		AQƊƂĒᑬRCULP RCBxƎ[ްǂݍݗp
 *		֐̎x܂܂܂B
 *
 * \par pLq:
 *		AVR351: U̪̎gRCȖsZƕ⏞
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation: http://www.atmel.com \n
 *		xEҰ: avr@atmel.com
 *
 * $Revision: 4809 $
 * $Date: 2008-11-04 12:17:59 +0100 (ti, 04 nov 2008) $  \n
 *
 * 쌠 (c) 2008, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 *****************************************************************************/

// ݸٰ ̧
#include "RC_calib_oscsampleif.h"
#include "ATmega8HVA_16HVA_signature.h"
#include <ioavr.h>
#include <inavr.h>

// `
#define SUCCESS					 0
#define FAILED					-1

// ^
uint16_t OSIsampleClockPeriod (uint8_t clock_source);

/*! \brief ᑬRCԌvZ
 *
 *	^ꂽxŒᑬRCԂvZ܂BᑬRČvZp̎ް
 *	ƉpLqŋLqꂽ悤Ɏۂ̎vZ邽߂([ɐݒ肳ꂽ)
 *	[ްƋɎg܂Bʂms~1024łB]āA10ޯĂ
 *	16ޯČŒ菬_`AA0x XXXX XX.xx xxxx xxxxmsƂČ邱Ƃ
 *	܂B
 *
 *	\param  temperature ݂ł̉x(uint16_t)
 *	\return ms~1024(uint16_t)ł̌vZꂽᑬRC
 */
uint16_t CalculateSlowRCperiod (int16_t temperature)
{
	uint16_t slow_RC_period;
	int16_t  slow_RC_temperature_coeff;
	uint16_t calib_temperature;

	/* [񂩂Kvްǂ݂܂Bꂪ̎ɍXȂ鏑݂ɑ
	 * ĕ邽߁A̒xԂ͒Ȍ݂6łSPMCSRڼ޽
	 * ւ̱邽߂łB
	 */
	slow_RC_period = READ_SIGNATUREBYTE(SIG_SLOW_RC_L);

	// Ȍ݂6łSPMCSRڼ޽݂B
	__delay_cycles(2);

	slow_RC_period |= READ_SIGNATUREBYTE(SIG_SLOW_RC_H) << 8;

	// Ȍ݂6łSPMCSRڼ޽݂B
	__delay_cycles(2);

	slow_RC_temperature_coeff = READ_SIGNATUREBYTE(SIG_SLOW_RC_PRED_L);

	// Ȍ݂6łSPMCSRڼ޽݂B
	__delay_cycles(2);

	slow_RC_temperature_coeff |= READ_SIGNATUREBYTE(SIG_SLOW_RC_PRED_H) << 8;

	// Ȍ݂6łSPMCSRڼ޽݂B
	__delay_cycles(2);

	calib_temperature = READ_SIGNATUREBYTE(SIG_TEMPERATURE_HOT) + ZERO_C_IN_KELVIN;

	return (uint16_t)(slow_RC_period - ((temperature - calib_temperature)*slow_RC_temperature_coeff)/64);
}

/*! \brief sɒᑬRCUɑ΂čRCZ
 *
 *  TĂlݒlɋ߂߁A`s܂BFOSCCALƂ̉
 *  ̋܂BAʋ擞BɎgł̔тA
 *  ]Ă蒷p͈͂^邽߁AFOSC SEGMENT[޲Ăg܂B
 *  FOSCFOSCł̍ŒႢg^钼Oł̍ŏ
 *  ̒lłBႢ̒ꂩA܂͊̏ɒBꍇA͈̔͂S
 *  xɓnFOSCCAL𒲐̂ɏ[Ȕ͈͂ƒ񋟂ĂāÂɉ
 *  Ă̂ŁA FOSCCALlIŎsԂ܂B
 *
 *  ̋Es܂񂪁AႦǧʂł̔тɏoƂĂA
 *  FOSCCALl͈͊OłAgZׂł邱Ƃɒӂ
 *  BFOSCCALlFOSCCALł̍ŒlFOSC SEGMENTԂ̏ꍇA
 *  ͈͂̒lI΂邩܂B
 *
 *  v͕ߊlU̪̎͊荞ٰ݂ŏ邽߂߰
 *  ޖ@Ŏg܂B
 *
 *  \param   cal_RC_period	ms~1024ł̒ᑬRC
 *  \return  Status			#SUCCESS܂#FAILED
 */
int8_t CalibrateFastRCruntime (uint16_t cal_RC_period)
{
	uint16_t target_period;
	int16_t  error;
	int16_t  last_error;
	uint8_t  fosccal_saved;

	/* [񂩂Kvްǂݍ݁B̎ɍXȂ鏑݂ɑ΂ē
	 * Ȃ邽߁Ax͒Ȍ݂6łSPMCSR
	 * 邽߂łB
	 */
	uint8_t fosccal_default = READ_SIGNATUREBYTE(SIG_FOSCCAL_DEFAULT);

	// Ȍ݂6łSPMCSRڼ޽݂B
	__delay_cycles(2);

	uint8_t fosccal_segment = READ_SIGNATUREBYTE(SIG_FOSC_SEGMENT);

	uint8_t bottom_limit = fosccal_segment & 0xE0;
	uint8_t top_limit =  (fosccal_default & 0xE0) + 0x1F;

	// \SĂMHz
	target_period = cal_RC_period * FAST_RC_TARGET_MHZ;

	// ߂邽߂̏
	uint8_t  check_value;
	error = OSIsampleClockPeriod(SLOW_RC) - target_period;

	if(error > 0){
		// 
		check_value = bottom_limit + 0x1F;
		do {
			last_error = error;
			fosccal_saved = FOSCCAL;
			if ( FOSCCAL-- == check_value ){
				// ֍s̎gт邽߂fosccallgp
				FOSCCAL = fosccal_segment;
			} else if (FOSCCAL < bottom_limit){ 
				// ͈̔͂Ȃ̌̂ŊFOSCCALlI
				FOSCCAL = fosccal_default;
				return FAILED;
			}
			error = OSIsampleClockPeriod(SLOW_RC) - target_period;
		} while (error > 0);
	}else{
		// 㑤
		check_value = fosccal_segment + 0x01;
		do {
			last_error = error;
			fosccal_saved = FOSCCAL;
			if ( FOSCCAL++ == check_value ){
				// 㑤֍s̎gт邽߂fosccallgp
				FOSCCAL = fosccal_default & 0xE0;
			} else if ( FOSCCAL > top_limit ){ 
				// ͈̔͂Ȃ̌̂ŊFOSCCALlI
				FOSCCAL = fosccal_default;
				return FAILED;
			}
			error = OSIsampleClockPeriod(SLOW_RC) - target_period;
		}while ( error < 0 );
	}

	/* אڌBgPɒႷ܂͍܂Ō̂ŁAŗǒl𓾂邽
	 * ߂ɗאڌKvƂ܂B2%xŏ[ȏꍇ͕svłBȗ
	 * ꍇAJłŖ60޲Đߖ񂵂܂B
	 */
	if(error < 0){
		// UgႢ?BȂ΍Ō̌덷(Βl)菬𒲍
		if (last_error < -error){
			FOSCCAL = fosccal_saved;
		}
	}else{
		// U͐?BȂΎ̂ႢFOSCCALݒ
		if (-last_error < error){
			FOSCCAL = fosccal_saved;
		}
	}

	return SUCCESS;
}

/*! \brief ᑬRCɑ΂ULP RC𑪒
 *
 *  U̪̎gĎQƊƂĒᑬRCULP RC̎肳܂B
 *  ʂms~1024łB]Ă10ޯĂ16ޯČŒ菬_`AA
 *  0x XXXX XX.xx xxxx xxxxƂČ邱Ƃł܂B
 *
 *  \param   cal_RC_period	(uint16_t)
 *  \return  ULP RC period	(uint16_t)
 */
uint16_t MeasureULPRCperiod (uint16_t cal_RC_period)
{
	uint16_t slow_RC_measurement, ULP_RC_measurement;
	uint32_t result;

	slow_RC_measurement = OSIsampleClockPeriod(SLOW_RC);
	ULP_RC_measurement = OSIsampleClockPeriod(ULP_RC);

	result = (uint32_t)cal_RC_period * ULP_RC_measurement / slow_RC_measurement;
	return (uint16_t)result;
}

/*! \brief OuꂽOSIۯ𑪒
 *
 *  OuꂽU̪̎ ۯRC_CALIB_CYCLESōRCۯ
 *  𑪒肵܂BOuATmega16HVAɑ΂128Aosi_cycles͑\I8
 *  ŁAI񂾓͸ۯɑ΂čv1024^܂Bp\ȓ͂͒ᑬRC
 *  ULP RCłB
 *
 *  x: ٰ݂OCR01̈ꂾlÂɍZɎg鍂RC
 *		  2~16ł邱ƂmɂĂB
 *
 *  \param   clock_source	(uint8_t)
 *  \return  I񂾸ۯ1024ۯł̍RC (uint16_t)
 */
uint16_t OSIsampleClockPeriod (uint8_t clock_source)
{
	uint16_t initial_capture, final_capture, result;

	// OSIƑI
	OSICSR = clock_source | (1 << OSIEN);

	// 16ޯēA~[N
	TCCR0A = (1 << TCW0) | (1 << ICEN0) | (0 << ICS0);

	// 1/1Ouősv0
	TCCR0B = T0_PRESCALER;

	// 荞ݗv׸މ
	TIFR0 |= (1 << ICF0);

	// [҂
	do {} while(!(TIFR0 & (1 << ICF0)));
	initial_capture = OCR0A;
	initial_capture |= OCR0B << 8;

	// 荞ݗv׸މ
	TIFR0 |= (1 << ICF0);

	for(uint8_t i = 0 ; i < RC_CALIB_CYCLES ; i++) {
		// [҂
		do {} while(!(TIFR0 & (1 << ICF0)));
		TIFR0 |= (1 << ICF0);
	}
	final_capture = OCR0A;
	final_capture |= OCR0B << 8;

	// ̍s͕l܂񂪁Aʂ^܂B
	result = final_capture - initial_capture;

	return result;
}
